// USBVoltmeterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "USBVoltmeter.h"
#include "USBVoltmeterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSBVoltmeterDlg dialog

CUSBVoltmeterDlg::CUSBVoltmeterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSBVoltmeterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUSBVoltmeterDlg)
	m_port = 0;
	m_vol = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSBVoltmeterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUSBVoltmeterDlg)
	DDX_Text(pDX, IDC_EDIT1, m_port);
	DDX_Text(pDX, IDC_VOL, m_vol);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUSBVoltmeterDlg, CDialog)
	//{{AFX_MSG_MAP(CUSBVoltmeterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnOpen)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSBVoltmeterDlg message handlers

BOOL CUSBVoltmeterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUSBVoltmeterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUSBVoltmeterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUSBVoltmeterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUSBVoltmeterDlg::OnOpen() 
{
	// TODO: Add your control notification handler code here

  UpdateData( true );

  if( this->m_hFile != NULL ) CloseHandle( m_hFile );
  
  char COM_string[32];
  DCB dcb;	

	sprintf(COM_string,"\\\\.\\COM%d", this->m_port);
	m_hFile = CreateFile(COM_string, GENERIC_READ|GENERIC_WRITE, 0, NULL,						
	    OPEN_EXISTING, 0,NULL);

	if( m_hFile != INVALID_HANDLE_VALUE )
	{		
    GetCommState(m_hFile, &dcb);

		dcb.BaudRate  = CBR_9600;
		dcb.ByteSize  = 8;             
		dcb.Parity    = NOPARITY;        
		dcb.StopBits  = ONESTOPBIT;    

		COMMTIMEOUTS CommTimeOuts;
		CommTimeOuts.ReadIntervalTimeout          = MAXDWORD;
		CommTimeOuts.ReadTotalTimeoutMultiplier   = 0;
		CommTimeOuts.ReadTotalTimeoutConstant     = 0;
		CommTimeOuts.WriteTotalTimeoutMultiplier  = 0;
		CommTimeOuts.WriteTotalTimeoutConstant    = 1000;
		SetCommTimeouts(m_hFile, &CommTimeOuts);
		SetCommState(m_hFile, &dcb);
	}
	else 
	{
		MessageBox("Can`t Open Port", "Error", MB_ICONERROR);	
		return;
	}
	
  MessageBox("Open OK", "Info", MB_ICONINFORMATION);


  DWORD lpdwBytesWritten;
  char buf[32];
  int len = sprintf(buf, "$KE,ADC,5\r\n"); 
  WriteFile(m_hFile, buf, len, &lpdwBytesWritten, NULL);    

  SetTimer(1, 250, NULL);
	
}

void CUSBVoltmeterDlg::OnTimer(UINT nIDEvent) 
{  
  DWORD dwBytesRead;
	unsigned char pBuff[128];

	ReadFile( m_hFile, &pBuff, sizeof(pBuff), &dwBytesRead, NULL ); 

  unsigned int offset = 0;
  int adc_value = 0;
  char data[4];
  
  if( dwBytesRead > 0 )
	{
    while( offset < dwBytesRead )
    {
      if( memcmp(pBuff + offset, "#ADC,", 5) == 0 ) 
      {        
        memcpy( data, pBuff + 5, 4 );
        adc_value = atoi( data );
        break;
      }
      offset += 1;
    }
  }

  double fadc = ((double)adc_value*5.0)/1023.0;
  this->m_vol.Format("%f V", fadc); 
  UpdateData( false );
	  
  PurgeComm( m_hFile, PURGE_TXCLEAR | PURGE_RXCLEAR );

	CDialog::OnTimer(nIDEvent);
}
